import { generateUuid } from '../generateUuid.js';
import { TriggerCustomEvent } from '../Profiles/Core/Actions/TriggerCustomEvent.js';
import { OnCustomEvent } from '../Profiles/Core/Events/OnCustomEvent.js';
export class Graph {
    constructor(registry) {
        this.registry = registry;
        this.name = '';
        this.nodes = {};
        this.variables = {};
        this.customEvents = {};
        this.metadata = {};
        this.localNodeRegistry = {};
    }
    registerLocalNodeTypes() {
        Object.keys(this.localNodeRegistry).forEach((nodeType) => {
            delete this.localNodeRegistry[nodeType];
        });
        Object.keys(this.customEvents).forEach((customEventId) => {
            this.localNodeRegistry[`event/customEvent/${customEventId}`] = () => new OnCustomEvent(this, customEventId);
            this.localNodeRegistry[`action/triggerCustomEvent/${customEventId}`] =
                () => new TriggerCustomEvent(this, customEventId);
        });
    }
    createNode(nodeType, nodeId = generateUuid()) {
        if (nodeType in this.localNodeRegistry) {
            const node = this.localNodeRegistry[nodeType]();
            node.id = nodeId;
            return node;
        }
        return this.registry.nodes.create(nodeType, nodeId);
    }
}
//# sourceMappingURL=Graph.js.map