import { Socket } from '../../Sockets/Socket.js';
import { Node } from '../Node.js';
export class In3Out1FuncNode extends Node {
    constructor(nodeName, input1ValueType, input2ValueType, input3ValueType, outputValueType, binaryEvalFunc) {
        super('Logic', nodeName, [
            new Socket(input1ValueType, 'a'),
            new Socket(input2ValueType, 'b'),
            new Socket(input3ValueType, 'c')
        ], [new Socket(outputValueType, 'result')], (context) => {
            context.writeOutput('result', this.binaryEvalFunc(context.readInput('a'), context.readInput('b'), context.readInput('c')));
        });
        this.binaryEvalFunc = binaryEvalFunc;
    }
}
//# sourceMappingURL=In3Out1FuncNode.js.map