import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class ForLoop extends Node {
    constructor() {
        super('Flow', 'flow/forLoop', [
            new Socket('flow', 'flow'),
            new Socket('integer', 'startIndex'),
            new Socket('integer', 'endIndex')
        ], [
            new Socket('flow', 'loopBody'),
            new Socket('integer', 'index'),
            new Socket('flow', 'completed')
        ], (context) => {
            const startIndex = context.readInput('startIndex');
            const endIndex = context.readInput('endIndex');
            const loopBodyIteration = function loopBodyIteration(i) {
                if (i < endIndex) {
                    context.writeOutput('index', i);
                    context.commit('loopBody', () => {
                        loopBodyIteration(i + 1n);
                    });
                }
                else {
                    context.commit('completed');
                }
            };
            loopBodyIteration(startIndex);
        });
    }
}
//# sourceMappingURL=ForLoop.js.map