import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class SetSceneProperty extends Node {
    constructor(nodeName, valueTypeName) {
        super('Action', nodeName, [
            new Socket('flow', 'flow'),
            new Socket('string', 'jsonPath'),
            new Socket(valueTypeName, 'value')
        ], [new Socket('flow', 'flow')], (context) => {
            const scene = context.graph.registry.abstractions.get('IScene');
            const value = context.readInput('value');
            scene.setProperty(context.readInput('jsonPath'), valueTypeName, value);
        });
        this.valueTypeName = valueTypeName;
    }
}
//# sourceMappingURL=SetSceneProperty.js.map