import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VecElements extends Node {
    constructor(nodeTypeName, valueTypeName, elementNames = ['x', 'y', 'z', 'w'], toArray) {
        super('Logic', nodeTypeName, [new Socket(valueTypeName, 'value')], elementNames.map((elementName) => new Socket('float', elementName)), (context) => {
            const value = context.readInput('value');
            const elementValues = elementNames.map(() => 0);
            toArray(value, elementValues, 0);
            elementNames.forEach((elementName, index) => context.writeOutput(elementName, elementValues[index]));
        });
    }
}
//# sourceMappingURL=VecElements.js.map